VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.2#0"; "mscomctl.OCX"
Begin VB.Form frmMain 
   Caption         =   "MediaTranscode Sample"
   ClientHeight    =   1785
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   9375
   LinkTopic       =   "Form1"
   ScaleHeight     =   119
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   625
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "Options"
      Height          =   975
      Left            =   2280
      TabIndex        =   3
      Top             =   60
      Width           =   6975
      Begin VB.CheckBox Check1 
         Caption         =   "AlwaysReencode"
         Height          =   285
         Left            =   120
         TabIndex        =   7
         Top             =   270
         Width           =   1695
      End
      Begin VB.CheckBox Check2 
         Caption         =   "HardwareAccelerationEnabled"
         Height          =   285
         Left            =   3450
         TabIndex        =   6
         Top             =   270
         Width           =   2625
      End
      Begin VB.OptionButton Option1 
         Caption         =   "MediaVideoProcessingAlgorithm Default"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   5
         Top             =   630
         Width           =   3255
      End
      Begin VB.OptionButton Option1 
         Caption         =   "MediaVideoProcessingAlgorithm MrfCrf444"
         Height          =   255
         Index           =   1
         Left            =   3450
         TabIndex        =   4
         Top             =   630
         Width           =   3405
      End
   End
   Begin MSComctlLib.ProgressBar ProgressBar1 
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   1080
      Width           =   9150
      _ExtentX        =   16140
      _ExtentY        =   503
      _Version        =   393216
      BorderStyle     =   1
      Appearance      =   0
      Scrolling       =   1
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Transcode"
      Height          =   870
      Left            =   120
      TabIndex        =   0
      Top             =   150
      Width           =   2115
   End
   Begin VB.Label Label1 
      Height          =   225
      Left            =   120
      TabIndex        =   2
      Top             =   1440
      Width           =   9150
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 08/2022

Option Explicit

Private m_Time As Double
Private WithEvents cMediaTranscode As clsMediaTranscode
Attribute cMediaTranscode.VB_VarHelpID = -1

Private Sub Form_Load()
    
    With ProgressBar1
        .Min = 0
        .Max = 100
    End With
    
    Command1.Enabled = False
    Frame1.Enabled = False
    
    Set cMediaTranscode = New clsMediaTranscode
    
    If cMediaTranscode.IsInitialized Then
        
        Command1.Enabled = True
        Frame1.Enabled = True
        
        Check1.Value = cMediaTranscode.AlwaysReencode
        Check2.Value = cMediaTranscode.HardwareAccelerationEnabled
        
        If cMediaTranscode.VideoProcessingAlgorithm = MediaVideoProcessingAlgorithm_Default Then
            Option1(0).Value = True
        Else
            Option1(1).Value = True
        End If
    End If
    
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set cMediaTranscode = Nothing
End Sub

Private Sub Command1_Click()

    Command1.Enabled = False
    Frame1.Enabled = False
    
    m_Time = Timer
        
    ' Audio to Audio
    ' Video to Audio
    Call cMediaTranscode.TranscodeFileToAudio("D:\test_org.wav", "D:\new", AudioProfile_FLAC)
        
    ' Video to Video
    ' Audio to Video
    'Call cMediaTranscode.TranscodeFileToVideo("D:\test_org.mp4", "D:\new", VideoProfile_HEVC)
        
End Sub

Private Sub cMediaTranscode_CompletedProgress(ByVal Value As Double)
    ProgressBar1.Value = Value
End Sub

Private Sub cMediaTranscode_CompletedStatus(ByVal Value As AsyncStatus)

    Dim strText As String
    
    Select Case Value
        Case AsyncStatus.Started
            strText = "Transcoding " & "Started"
        Case AsyncStatus.Completed
            strText = "Transcoding " & "Completed"
        Case AsyncStatus.Canceled
            strText = "Transcoding " & "Canceled"
        Case AsyncStatus.Error
            strText = "Transcoding " & "Error"
    End Select
    
    If Value <> Started Then
    
        Command1.Enabled = True
        Frame1.Enabled = True
        
        strText = strText & ": Time = " & Format$(((Timer - m_Time) * 1000), "###,####") & " sec"
        
    End If

    Me.Caption = strText
    

End Sub

Private Sub cMediaTranscode_FailureReason(ByVal Value As TranscodeFailureReason)

    Dim strText As String

    Select Case Value
        Case TranscodeFailureReason.TranscodeFailureReason_None
            strText = "None"
        Case TranscodeFailureReason.TranscodeFailureReason_Unknown
            strText = "Unknown"
        Case TranscodeFailureReason.TranscodeFailureReason_InvalidProfile
            strText = "InvalidProfile"
        Case TranscodeFailureReason.TranscodeFailureReason_CodecNotFound
            strText = "CodecNotFound"
    End Select

    If Value <> TranscodeFailureReason_None Then
    
        Command1.Enabled = True
        Frame1.Enabled = True
        
    End If

    Label1.Caption = "MediaFailureReason: " & strText

End Sub

Private Sub Check1_Click()
    cMediaTranscode.AlwaysReencode = Check1.Value
End Sub

Private Sub Check2_Click()
    cMediaTranscode.HardwareAccelerationEnabled = Check2.Value
End Sub

Private Sub Option1_Click(Index As Integer)
    If Index = 0 Then
        cMediaTranscode.VideoProcessingAlgorithm = MediaVideoProcessingAlgorithm_Default
    Else
        cMediaTranscode.VideoProcessingAlgorithm = MediaVideoProcessingAlgorithm_MrfCrf444
    End If
End Sub
